﻿var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (n) { var f = "", e, t, i, s, h, o, r, u = 0; for (n = Base64._utf8_encode(n); u < n.length;) e = n.charCodeAt(u++), t = n.charCodeAt(u++), i = n.charCodeAt(u++), s = e >> 2, h = (e & 3) << 4 | t >> 4, o = (t & 15) << 2 | i >> 6, r = i & 63, isNaN(t) ? o = r = 64 : isNaN(i) && (r = 64), f = f + this._keyStr.charAt(s) + this._keyStr.charAt(h) + this._keyStr.charAt(o) + this._keyStr.charAt(r); return f }, decode: function (n) { var t = "", e, o, s, h, u, r, f, i = 0; for (n = n.replace(/[^A-Za-z0-9\+\/\=]/g, ""); i < n.length;) h = this._keyStr.indexOf(n.charAt(i++)), u = this._keyStr.indexOf(n.charAt(i++)), r = this._keyStr.indexOf(n.charAt(i++)), f = this._keyStr.indexOf(n.charAt(i++)), e = h << 2 | u >> 4, o = (u & 15) << 4 | r >> 2, s = (r & 3) << 6 | f, t = t + String.fromCharCode(e), r != 64 && (t = t + String.fromCharCode(o)), f != 64 && (t = t + String.fromCharCode(s)); return Base64._utf8_decode(t) }, _utf8_encode: function (n) { var i, r, t; for (n = n.replace(/\r\n/g, "\n"), i = "", r = 0; r < n.length; r++) t = n.charCodeAt(r), t < 128 ? i += String.fromCharCode(t) : t > 127 && t < 2048 ? (i += String.fromCharCode(t >> 6 | 192), i += String.fromCharCode(t & 63 | 128)) : (i += String.fromCharCode(t >> 12 | 224), i += String.fromCharCode(t >> 6 & 63 | 128), i += String.fromCharCode(t & 63 | 128)); return i }, _utf8_decode: function (n) { for (var r = "", t = 0, i = c1 = c2 = 0; t < n.length;) i = n.charCodeAt(t), i < 128 ? (r += String.fromCharCode(i), t++) : i > 191 && i < 224 ? (c2 = n.charCodeAt(t + 1), r += String.fromCharCode((i & 31) << 6 | c2 & 63), t += 2) : (c2 = n.charCodeAt(t + 1), c3 = n.charCodeAt(t + 2), r += String.fromCharCode((i & 15) << 12 | (c2 & 63) << 6 | c3 & 63), t += 3); return r } };

function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
}

console.log('Username: ' + document.getElementById("uName").value);
console.log('RelyingPartyId: ' + document.getElementById("rID").value);
console.log('Challenge: ' + document.getElementById("rChallenge").value);

// Update challenge string to expected Uint8Array
var byteCharacters = atob(document.getElementById("rChallenge").value);
var byteNumbers = new Array(byteCharacters.length);
for (var i = 0; i < byteCharacters.length; i++) {
    byteNumbers[i] = byteCharacters.charCodeAt(i);
}
var challenge = new Uint8Array(byteNumbers);

// Request ES256 algorithm
var pubKeyCredParams = [
    {
        type: "public-key",
        alg: -7
    }
];

// Relying party details
var rp = {
    name: "Test Site",
    id: document.getElementById("rID").value
};

// User handle
var user = {
    name: document.getElementById("uName").value,
    displayName: document.getElementById("uName").value,
    id: new TextEncoder("utf-8").encode(document.getElementById("uName").value)
};
var publicKey = { challenge, pubKeyCredParams, rp, user };

navigator.credentials.create({ publicKey }).then((credentials) => {

    var publicKeyCredentialToJSON = (pubKeyCred) => {
        if (pubKeyCred instanceof Array) {
            let arr = [];
            for (let i of pubKeyCred)
                arr.push(publicKeyCredentialToJSON(i));

            return arr;
        }

        if (pubKeyCred instanceof ArrayBuffer) {
            return btoa(String.fromCharCode.apply(null, new Uint8Array(pubKeyCred)));
        }

        if (pubKeyCred instanceof Object) {
            let obj = {};

            for (let key in pubKeyCred) {
                obj[key] = publicKeyCredentialToJSON(pubKeyCred[key]);
            }

            return obj;
        }

        return pubKeyCred;
    }

    var credentialsAsJson = publicKeyCredentialToJSON(credentials);

    //$.ajax({
    //    url: '/Fido/RegisterCallback',
    //    type: 'POST',
    //    contentType: 'application/json',
    //    data: JSON.stringify(credentialsAsJson),
    //    success: function (data) {
    //        document.open();
    //        document.write(data);
    //        document.close();
    //        //document.body.innerHTML = data;
    //        //window.location = data;
    //    }
    //});
    console.log("for RegisterCallback, credentialsAsJson = " + credentialsAsJson);
    var sJSON = null;
    try {
        sJSON = JSON.stringify(credentialsAsJson);
        //sJSON = Base64.decode(sJSON);
        sJSON = b64EncodeUnicode(sJSON);
        console.log("for RegisterCallback, sJSON= " + sJSON);
    } catch (e) {
        alert("In RegisterCallback Failed to convert JSON.stringify: " + e.message);
        console.log("In RegisterCallback Failed to convert JSON.stringify: " + e.message);
    }

    $.post("/Fido/FidoRegisterCallback", {
        strYubiJSON: sJSON
    }).done(function (data) {
        if (data != null) {
            if (data.includes("result")) {
                var obj = jQuery.parseJSON(data);
                var options = {};
                options['closeButton'] = true;
                options['positionClass'] = "toast-top-center";
                options['type'] = "error";
                var title = "Invalid Operation";
                toastr[options.type](obj.message, title, options);
            }
            else {
                window.location.href = data;
            }
        }
        else {
            var errorMsg = "Data is missing while returning from RegisterCallback";
            console.log(errorMsg);
            var obj = jQuery.parseJSON(data);
            var options = {};
            options['closeButton'] = true;
            options['positionClass'] = "toast-top-center";
            options['type'] = "error";
            var title = "Invalid Operation";
            toastr[options.type](errorMsg, title, options);
        }
    }).fail(function (e) {
        console.log("printing e in fail section fo RegisterCallback= " + e);
        alert("Call to RegisterCallback failed");

    });
});